/*
    Copyright (c) 2015 digitalSTROM AG, Zurich, Switzerland

    Authors: Christian Hitz, digitalSTROM AG <christian.hitz@digitalstrom.com>
             Michael Tross, digitalSTROM AG <michael.tross@digitalstrom.com>
             Reto Flütsch, digitalSTROM AG <reto.fluetsch@digitalstrom.com>

    This file is part of vdSM.

    vdSM is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 2 of the License.
    

    vdSM is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vdSM. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DEVICE_API_H_
#define DEVICE_API_H_

#include "qp_port.h"
#include "scene.h"
#include "output_channel.h"

void device_api_send_scene(const char *dsuid, Scene scene, bool force);
void device_api_send_undo_scene_number(const char *dsuid, Scene scene);
void device_api_send_undo_scene(const char *dsuid);
void device_api_send_save_scene(const char *dsuid, Scene scene);
void device_api_send_min_scene(const char *dsuid, Scene scene);
void device_api_send_local_prio(const char *dsuid, Scene scene);
void device_api_get_parameter(const char* dsuid, uint8_t paramBank, uint8_t paramOffset);
void device_api_identify(const char *dsuid);
void device_api_set_outval(const char *dsuid, uint8_t channel, uint16_t outval);
bool device_api_set_zone(const char *dsuid, uint16_t zoneId);
void device_api_add_group(const char *dsuid, uint8_t groupId);
void device_api_remove_group(const char *dsuid, uint8_t groupId);
void device_api_send_dim_channel(const char *dsuid, uint8_t channel, OPCOperation mode,
                                 uint8_t area);

#endif /* DEVICE_API_H_ */
