/*
    Copyright (c) 2015 digitalSTROM AG, Zurich, Switzerland

    Author: Sergey 'Jin' Bostandzhyan <jin@dev.digitalstrom.org>

    This file is part of vdSM.

    vdSM is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 2 of the License.
    

    vdSM is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vdSM. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __VDSM_MSG_UTIL_H__
#define __VDSM_MSG_UTIL_H__

#include <stdint.h>
#include "types.h"
#include "messages/vdcapi.pb-c.h"

bool msgutil_get_int(const Vdcapi__PropertyValue *msg, int64_t *out);
bool msgutil_get_uint(const Vdcapi__PropertyValue *msg, uint64_t *out);
bool msgutil_get_bool(const Vdcapi__PropertyValue *msg, bool *out);
bool msgutil_get_double(const Vdcapi__PropertyValue *msg, double *out);
// WARNING: returned string is not a copy but a pointer to the string in msg
bool msgutil_get_string(const Vdcapi__PropertyValue *msg, const char **out);

Vdcapi__PropertyValue *msgutil_get_property(Vdcapi__VdcResponseGetProperty *prop,
                                            const char *name);

Vdcapi__PropertyValue *msgutil_get_push_property(Vdcapi__VdcSendPushProperty *prop,
                                                 const char *name);

bool msgutil_get_int_property(Vdcapi__VdcResponseGetProperty *prop,
                              const char *name,
                              int64_t min, int64_t max, int64_t *out);

bool msgutil_get_uint_property(Vdcapi__VdcResponseGetProperty *prop,
                               const char *name, uint64_t maxval,
                               uint64_t *out);

bool msgutil_get_double_property(Vdcapi__VdcResponseGetProperty *prop,
                                 const char *name, double *out);

bool msgutil_get_bool_property(Vdcapi__VdcResponseGetProperty *prop,
                               const char *name, bool *out);

// WARNING: returned string is not a copy but a pointer to the string in msg
bool msgutil_get_string_property(Vdcapi__VdcResponseGetProperty *prop,
                                 const char *name,
                                 const char **out);

#endif//__VDSM_MSG_Util_H__
