/*
    Copyright (c) 2015 digitalSTROM AG, Zurich, Switzerland

    Authors: Christian Hitz, digitalSTROM AG <christian.hitz@digitalstrom.com>
             Michael Tross, digitalSTROM AG <michael.tross@digitalstrom.com>
             Reto Flütsch, digitalSTROM AG <reto.fluetsch@digitalstrom.com>

    This file is part of vdSM.

    vdSM is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 2 of the License.
    

    vdSM is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vdSM. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef SELECTA_SOCKET_H_
#define SELECTA_SOCKET_H_

#include <digitalSTROM/dsuid.h>
#include "types.h"
#include "scene.h"
#include "output_channel.h"

typedef struct _device_dsuid_t {
    struct _device_dsuid_t* next;
    char dsuid[DSUID_STR_LEN];
} device_dsuid_t;

void SelectASocket_SendSceneZoneGroup(uint8_t localZoneId, uint8_t groupId, Scene scene, bool force);
void SelectASocket_SendSceneDevice(uint16_t deviceId, Scene scene, bool force);
void SelectASocket_SendUndoSceneNumberZoneGroup(uint8_t localZoneId, uint8_t groupId, Scene scene);
void SelectASocket_SendUndoSceneZoneGroup(uint8_t localZoneId, uint8_t groupId);
void SelectASocket_SendUndoSceneNumberDevice(uint16_t deviceId, Scene scene);
void SelectASocket_SendUndoSceneDevice(uint16_t deviceId);
void SelectASocket_SendBlinkZoneGroup(uint8_t localZoneId, uint8_t groupId);
void SelectASocket_SendBlinkDevice(uint16_t deviceId);
void SelectASocket_SendSetSceneLocalPrioZoneGroup(uint8_t localZoneId, uint8_t groupId, Scene scene);
void SelectASocket_CallSceneMinZoneGroup(uint8_t localZoneId, uint8_t groupId, Scene scene);
void SelectASocket_SendProgOnZoneGroup(uint16_t zoneId, uint8_t groupId);
void SelectASocket_SendProgOffZoneGroup(uint16_t zoneId, uint8_t groupId);
void SelectASocket_SendProgOnDevice(uint16_t deviceId);
void SelectASocket_SendProgOffDevice(uint16_t deviceId);
void SelectASocket_SendSaveSceneZoneGroup(uint8_t zoneId, uint8_t groupId, Scene scene);
void SelectASocket_SendOPCDimDevice(uint16_t deviceId, OPCOperation operation, uint8_t channelId);
void SelectASocket_SendOPCDimZoneGroup(uint8_t zoneId, uint8_t groupId, OPCOperation operation, uint8_t channelId);
void SelectASocket_SendSaveSceneDevice(uint16_t deviceId, Scene scene);
void SelectASocket_SendSetOutvalZoneGroup(uint8_t localZoneId, uint8_t groupId, uint8_t outval);
void SelectASocket_SendSetOutvalDevice(uint16_t deviceId, uint8_t outval);
void SelectASocket_SendAddGroupDevice(uint16_t deviceId, uint8_t groupId);
void SelectASocket_SendRemoveGroupDevice(uint16_t deviceId, uint8_t groupId);
void SelectASocket_SendRemoveGroupFromZone(uint8_t localZoneId, uint8_t groupId);

#endif /* SELECTA_SOCKET_H_ */
